module.exports = grammar({
  name: 'scheme',
  rules: {
    source_file: $ => $._sexp0,
    // level 0
    _sexp0: $ => choice($._paren0, $.symbol, $.char, $.bool, $.string, $.quoted0, $.quasiquoted0, $.unquoted0, $.spliced0),
    quoted0: $ => seq(/'/, $._sexp0),
    quasiquoted0: $ => seq('`', $._sexp0),
    unquoted0: $ => seq(',', $._sexp0),
    spliced0: $ => seq(',@', $._sexp0),
    _paren0: $ => seq($.open0 , optional(seq(repeat1($._sexp1), optional(seq('.', $._sexp1)))) , $.close0),
    // level 1
    _sexp1: $ => choice($._paren1, $.symbol, $.char, $.bool, $.string, $.quoted1, $.quasiquoted1, $.unquoted1, $.spliced1),
    quoted1: $ => seq(/'/, $._sexp1),
    quasiquoted1: $ => seq('`', $._sexp1),
    unquoted1: $ => seq(',', $._sexp1),
    spliced1: $ => seq(',@', $._sexp1),
    _paren1: $ => seq($.open1, optional(seq(repeat1($._sexp2), optional(seq('.', $._sexp2)))) , $.close1),
    // level 2
    _sexp2: $ => choice($._paren2, $.symbol, $.char, $.bool, $.string, $.quoted2, $.quasiquoted2, $.unquoted2, $.spliced2),
    quoted2: $ => seq(/'/, $._sexp2),
    quasiquoted2: $ => seq('`', $._sexp2),
    unquoted2: $ => seq(',', $._sexp2),
    spliced2: $ => seq(',@', $._sexp2),
    _paren2: $ => seq($.open2, optional(seq(repeat1($._sexp3), optional(seq('.', $._sexp3)))) , $.close2),
    // level 3
    _sexp3: $ => choice($._paren3, $.symbol, $.char, $.bool, $.string, $.quoted3, $.quasiquoted3, $.unquoted3, $.spliced3),
    quoted3: $ => seq(/'/, $._sexp3),
    quasiquoted3: $ => seq('`', $._sexp3),
    unquoted3: $ => seq(',', $._sexp3),
    spliced3: $ => seq(',@', $._sexp3),
    _paren3: $ => seq($.open3, optional(seq(repeat1($._sexp4), optional(seq('.', $._sexp4)))) , $.close3),
    // level 4
    _sexp4: $ => choice($._paren4, $.symbol, $.char, $.bool, $.string, $.quoted4, $.quasiquoted4, $.unquoted4, $.spliced4),
    quoted4: $ => seq(/'/, $._sexp4),
    quasiquoted4: $ => seq('`', $._sexp4),
    unquoted4: $ => seq(',', $._sexp4),
    spliced4: $ => seq(',@', $._sexp4),
    _paren4: $ => seq($.open4 , optional(seq(repeat1($._sexp5), optional(seq('.', $._sexp5)))) , $.close4),
    // level 5
    _sexp5: $ => choice($._paren5, $.symbol, $.char, $.bool, $.string, $.quoted5, $.quasiquoted5, $.unquoted5, $.spliced5),
    quoted5: $ => seq(/'/, $._sexp5),
    quasiquoted5: $ => seq('`', $._sexp5),
    unquoted5: $ => seq(',', $._sexp5),
    spliced5: $ => seq(',@', $._sexp5),
    _paren5: $ => seq($.open5 , optional(seq(repeat1($._sexp0), optional(seq('.', $._sexp0)))) , $.close5),

    // unleveled
    symbol: $ => prec.left(3, repeat1($._letter)),
    bool: $ => /#[ft]/,
    char: $ => /#\\./,
    string: $ => choice($._realString, $._emptyString),
    _realString : $ => seq($.stringQuote, $.stringContent, $.stringQuote),
    _emptyString : $ => '""',
    stringQuote: $ => '"',
    stringContent: $ => repeat1($._stringPart),
    _stringPart: $ => choice($.stringChar, $.escapeChar),
    stringChar: $ => /[^"\\]/,
    escapeChar: $ => /\\["'\\abnfst]/,
    _letter: $ => /[^\(\)\[\]\{\}"'.`,@\s;]/,

    // opening and closing parenthesis
    open0: $ => '(',
    close0: $ => ')',
    open1: $ => '(',
    close1: $ => ')',
    open2: $ => '(',
    close2: $ => ')',
    open3: $ => '(',
    close3: $ => ')',
    open4: $ => '(',
    close4: $ => ')',
    open5: $ => '(',
    close5: $ => ')'
  }
});
